﻿namespace H2Guerilla.Controls
{
    using core.TagInterface;
    using H2Guerilla;
    using System;
    using System.ComponentModel;
    using System.Drawing;
    using System.Windows.Forms;

    public class notSupported : UserControl
    {
        private IContainer components;
        private Label label1;

        public notSupported(BaseObject baseObject)
        {
            this.InitializeComponent();
            this.label1.Text = "Not supported - " + baseObject.Type.ToString();
            Main.skin.skinChanged += new EventHandler(this.skin_skinChanged);
            this.BackColor = Main.skin.itemBackgroundColor;
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing && (this.components != null))
            {
                this.components.Dispose();
            }
            base.Dispose(disposing);
        }

        private void InitializeComponent()
        {
            this.label1 = new Label();
            base.SuspendLayout();
            this.label1.AutoSize = true;
            this.label1.Location = new Point(12, 10);
            this.label1.Name = "label1";
            this.label1.Size = new Size(0x44, 13);
            this.label1.TabIndex = 0;
            this.label1.Text = "Place Holder";
            base.AutoScaleDimensions = new SizeF(6f, 13f);
            base.AutoScaleMode = AutoScaleMode.Font;
            this.AutoSize = true;
            base.AutoSizeMode = AutoSizeMode.GrowAndShrink;
            base.Controls.Add(this.label1);
            base.Name = "notSupported";
            base.Size = new Size(0x53, 0x17);
            base.ResumeLayout(false);
            base.PerformLayout();
        }

        private void skin_skinChanged(object sender, EventArgs e)
        {
            this.BackColor = Main.skin.itemBackgroundColor;
        }
    }
}

