﻿namespace H2Guerilla
{
    using core;
    using core.TagInterface;
    using H2Guerilla.Classes;
    using H2Guerilla.Forms;
    using H2Guerilla.Plugin;
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.Drawing;
    using System.Windows.Forms;
    using TD.SandBar;
    using Xceed.Zip;

    public class Main : Form
    {
        private IContainer components;
        public static List<TagBlockLayout> copyForReflexive = new List<TagBlockLayout>();
        public static Main mainForm = null;
        private MenuBar menuBar1;
        private MenuBarItem menuBarItem1;
        private MenuBarItem menuBarItem2;
        private MenuBarItem menuBarItem4;
        private MenuBarItem menuBarItem5;
        private MenuButtonItem menuButtonItem1;
        private MenuButtonItem menuButtonItem10;
        private MenuButtonItem menuButtonItem11;
        private MenuButtonItem menuButtonItem12;
        private MenuButtonItem menuButtonItem13;
        private MenuButtonItem menuButtonItem14;
        private MenuButtonItem menuButtonItem15;
        private MenuButtonItem menuButtonItem2;
        private MenuButtonItem menuButtonItem3;
        private MenuButtonItem menuButtonItem4;
        private MenuButtonItem menuButtonItem5;
        private MenuButtonItem menuButtonItem6;
        private MenuButtonItem menuButtonItem7;
        private MenuButtonItem menuButtonItem8;
        private MenuButtonItem menuButtonItem9;
        private int OpenWindows;
        public static ProgramSettings settings = new ProgramSettings();
        public static Skin skin = new Skin();
        private StatusStrip statusStrip1;
        private ToolStripProgressBar toolStripProgressBar1;
        private ToolStripStatusLabel toolStripStatusLabel1;

        public Main()
        {
            Licenser.LicenseKey = "ZIN33-TR67R-JHSZW-RGTA";
            this.InitializeComponent();
            Tag_Layouts.Layouts = new Tag_Layouts();
            mainForm = this;
            StatusHelper.reportProgress = this.toolStripProgressBar1.ProgressBar;
            StatusHelper.reportLabel = this.toolStripStatusLabel1;
            H2GPluginHelper.Plugins.Add(Application.StartupPath + @"\Libraries\");
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing && (this.components != null))
            {
                this.components.Dispose();
            }
            base.Dispose(disposing);
        }

        private void editor_FormClosed(object sender, FormClosedEventArgs e)
        {
            this.OpenWindows--;
            if (this.OpenWindows < 1)
            {
                this.menuBarItem4.Enabled = false;
                this.menuButtonItem2.Enabled = false;
            }
        }

        private void InitializeComponent()
        {
            this.menuBar1 = new MenuBar();
            this.menuBarItem1 = new MenuBarItem();
            this.menuButtonItem3 = new MenuButtonItem();
            this.menuButtonItem1 = new MenuButtonItem();
            this.menuButtonItem2 = new MenuButtonItem();
            this.menuButtonItem4 = new MenuButtonItem();
            this.menuBarItem2 = new MenuBarItem();
            this.menuButtonItem13 = new MenuButtonItem();
            this.menuButtonItem6 = new MenuButtonItem();
            this.menuBarItem4 = new MenuBarItem();
            this.menuButtonItem7 = new MenuButtonItem();
            this.menuButtonItem8 = new MenuButtonItem();
            this.menuButtonItem9 = new MenuButtonItem();
            this.menuButtonItem10 = new MenuButtonItem();
            this.menuButtonItem11 = new MenuButtonItem();
            this.menuButtonItem12 = new MenuButtonItem();
            this.menuBarItem5 = new MenuBarItem();
            this.menuButtonItem5 = new MenuButtonItem();
            this.statusStrip1 = new StatusStrip();
            this.toolStripStatusLabel1 = new ToolStripStatusLabel();
            this.toolStripProgressBar1 = new ToolStripProgressBar();
            this.menuButtonItem14 = new MenuButtonItem();
            this.menuButtonItem15 = new MenuButtonItem();
            this.statusStrip1.SuspendLayout();
            base.SuspendLayout();
            this.menuBar1.Guid = new Guid("d3aa35fe-b8d3-4b56-a588-2bdb76bc5922");
            this.menuBar1.Items.AddRange(new ToolbarItemBase[] { this.menuBarItem1, this.menuBarItem2, this.menuBarItem4, this.menuBarItem5 });
            this.menuBar1.Location = new Point(0, 0);
            this.menuBar1.Name = "menuBar1";
            this.menuBar1.OwnerForm = this;
            this.menuBar1.Size = new Size(660, 0x16);
            this.menuBar1.TabIndex = 3;
            this.menuBar1.Text = "menuBar1";
            this.menuBarItem1.Items.AddRange(new ToolbarItemBase[] { this.menuButtonItem3, this.menuButtonItem1, this.menuButtonItem2, this.menuButtonItem4 });
            this.menuBarItem1.Text = "&File";
            this.menuButtonItem3.Text = "New";
            this.menuButtonItem3.Activate += new EventHandler(this.menuButtonItem3_Activate);
            this.menuButtonItem1.Text = "Open";
            this.menuButtonItem1.Activate += new EventHandler(this.menuButtonItem1_Activate);
            this.menuButtonItem2.BeginGroup = true;
            this.menuButtonItem2.Enabled = false;
            this.menuButtonItem2.Text = "Save";
            this.menuButtonItem2.Activate += new EventHandler(this.menuButtonItem2_Activate);
            this.menuButtonItem4.BeginGroup = true;
            this.menuButtonItem4.Text = "Exit";
            this.menuButtonItem4.Activate += new EventHandler(this.menuButtonItem4_Activate);
            this.menuBarItem2.Items.AddRange(new ToolbarItemBase[] { this.menuButtonItem14, this.menuButtonItem15, this.menuButtonItem13, this.menuButtonItem6 });
            this.menuBarItem2.Text = "&Edit";
            this.menuButtonItem13.BeginGroup = true;
            this.menuButtonItem13.Text = "Skin Options";
            this.menuButtonItem13.Activate += new EventHandler(this.menuButtonItem13_Activate);
            this.menuButtonItem6.BeginGroup = true;
            this.menuButtonItem6.Text = "Settings";
            this.menuButtonItem6.Activate += new EventHandler(this.menuButtonItem6_Activate);
            this.menuBarItem4.Enabled = false;
            this.menuBarItem4.Items.AddRange(new ToolbarItemBase[] { this.menuButtonItem7, this.menuButtonItem8, this.menuButtonItem9, this.menuButtonItem10, this.menuButtonItem11, this.menuButtonItem12 });
            this.menuBarItem4.MdiWindowList = true;
            this.menuBarItem4.Text = "&Window";
            this.menuButtonItem7.Text = "Tile Horizontal";
            this.menuButtonItem7.Activate += new EventHandler(this.menuButtonItem7_Activate);
            this.menuButtonItem8.Text = "Title Vertical";
            this.menuButtonItem8.Activate += new EventHandler(this.menuButtonItem8_Activate);
            this.menuButtonItem9.Text = "Cascade";
            this.menuButtonItem9.Activate += new EventHandler(this.menuButtonItem9_Activate);
            this.menuButtonItem10.BeginGroup = true;
            this.menuButtonItem10.Text = "Minimize All";
            this.menuButtonItem10.Activate += new EventHandler(this.menuButtonItem10_Activate);
            this.menuButtonItem11.Text = "Restore All";
            this.menuButtonItem11.Activate += new EventHandler(this.menuButtonItem11_Activate);
            this.menuButtonItem12.BeginGroup = true;
            this.menuButtonItem12.Text = "Close All";
            this.menuButtonItem12.Activate += new EventHandler(this.menuButtonItem12_Activate);
            this.menuBarItem5.Items.AddRange(new ToolbarItemBase[] { this.menuButtonItem5 });
            this.menuBarItem5.Text = "&Help";
            this.menuButtonItem5.Text = "About";
            this.menuButtonItem5.Activate += new EventHandler(this.menuButtonItem5_Activate);
            this.statusStrip1.Items.AddRange(new ToolStripItem[] { this.toolStripStatusLabel1, this.toolStripProgressBar1 });
            this.statusStrip1.Location = new Point(0, 0x1d2);
            this.statusStrip1.Name = "statusStrip1";
            this.statusStrip1.Size = new Size(660, 0x16);
            this.statusStrip1.TabIndex = 5;
            this.statusStrip1.Text = "statusStrip1";
            this.toolStripStatusLabel1.Name = "toolStripStatusLabel1";
            this.toolStripStatusLabel1.Size = new Size(0x21f, 0x11);
            this.toolStripStatusLabel1.Spring = true;
            this.toolStripStatusLabel1.Text = "Ready";
            this.toolStripStatusLabel1.TextAlign = ContentAlignment.MiddleLeft;
            this.toolStripProgressBar1.Name = "toolStripProgressBar1";
            this.toolStripProgressBar1.Size = new Size(100, 0x10);
            this.menuButtonItem14.Text = "Database Creator";
            this.menuButtonItem14.Activate += new EventHandler(this.menuButtonItem14_Activate_1);
            this.menuButtonItem15.Text = "Database Extractor";
            this.menuButtonItem15.Activate += new EventHandler(this.menuButtonItem15_Activate);
            base.AutoScaleDimensions = new SizeF(6f, 13f);
            base.AutoScaleMode = AutoScaleMode.Font;
            base.ClientSize = new Size(660, 0x1e8);
            base.Controls.Add(this.statusStrip1);
            base.Controls.Add(this.menuBar1);
            base.IsMdiContainer = true;
            base.Name = "Main";
            this.Text = "H2 Guerilla";
            base.WindowState = FormWindowState.Maximized;
            this.statusStrip1.ResumeLayout(false);
            this.statusStrip1.PerformLayout();
            base.ResumeLayout(false);
            base.PerformLayout();
        }

        private void menuButtonItem1_Activate(object sender, EventArgs e)
        {
            OpenFileDialog dialog = new OpenFileDialog();
            string str = "";
            foreach (Tag_Category category in Tag_Layouts.Layouts)
            {
                if (category.HaloVersion == Map.HaloVersionEnum.Halo2)
                {
                    foreach (TagDefinition definition in category)
                    {
                        if (definition.Extension != "")
                        {
                            string str2 = str;
                            str = str2 + definition.TagType.Substring(0, 1).ToUpper() + definition.TagType.Substring(1, definition.TagType.Length - 1) + " Tags|*." + definition.Extension + "|";
                        }
                    }
                    continue;
                }
            }
            str = str.Remove(str.Length - 1, 1);
            dialog.Filter = "All Files|*.*|" + str;
            dialog.FilterIndex = 0;
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                Editor editor = new Editor(dialog.FileName);
                editor.FormClosed += new FormClosedEventHandler(this.editor_FormClosed);
                editor.MdiParent = this;
                editor.Show();
                this.OpenWindows++;
                this.menuBarItem4.Enabled = true;
                this.menuButtonItem2.Enabled = true;
            }
        }

        private void menuButtonItem10_Activate(object sender, EventArgs e)
        {
            foreach (Form form in base.MdiChildren)
            {
                form.WindowState = FormWindowState.Minimized;
            }
        }

        private void menuButtonItem11_Activate(object sender, EventArgs e)
        {
            foreach (Form form in base.MdiChildren)
            {
                form.WindowState = FormWindowState.Normal;
            }
        }

        private void menuButtonItem12_Activate(object sender, EventArgs e)
        {
            foreach (Form form in base.MdiChildren)
            {
                form.Close();
            }
        }

        private void menuButtonItem13_Activate(object sender, EventArgs e)
        {
            if ((skin == null) || skin.IsDisposed)
            {
                skin = new Skin();
            }
            skin.Show();
        }

        private void menuButtonItem14_Activate_1(object sender, EventArgs e)
        {
            new DatabaseCreate().ShowDialog();
        }

        private void menuButtonItem15_Activate(object sender, EventArgs e)
        {
            new DatabaseExtract().ShowDialog();
        }

        private void menuButtonItem2_Activate(object sender, EventArgs e)
        {
            ((Editor) base.ActiveMdiChild).SaveMeta();
        }

        private void menuButtonItem3_Activate(object sender, EventArgs e)
        {
            ChooseType type = new ChooseType();
            if (type.ShowDialog() == DialogResult.OK)
            {
                Editor editor = new Editor(type.tagDef);
                editor.FormClosed += new FormClosedEventHandler(this.editor_FormClosed);
                editor.MdiParent = this;
                editor.Show();
                this.OpenWindows++;
                this.menuBarItem4.Enabled = true;
                this.menuButtonItem2.Enabled = true;
            }
        }

        private void menuButtonItem4_Activate(object sender, EventArgs e)
        {
            Application.Exit();
        }

        private void menuButtonItem5_Activate(object sender, EventArgs e)
        {
            MessageBox.Show("Created by Anthony & Pokecancer", "H2Guerilla");
        }

        private void menuButtonItem6_Activate(object sender, EventArgs e)
        {
            settings.ShowDialog();
        }

        private void menuButtonItem7_Activate(object sender, EventArgs e)
        {
            base.LayoutMdi(MdiLayout.TileHorizontal);
        }

        private void menuButtonItem8_Activate(object sender, EventArgs e)
        {
            base.LayoutMdi(MdiLayout.TileVertical);
        }

        private void menuButtonItem9_Activate(object sender, EventArgs e)
        {
            base.LayoutMdi(MdiLayout.Cascade);
        }

        public void OpenWithFilePath(string filePath)
        {
            Editor editor = new Editor(filePath);
            editor.FormClosed += new FormClosedEventHandler(this.editor_FormClosed);
            editor.MdiParent = this;
            editor.Show();
            this.OpenWindows++;
            this.menuBarItem4.Enabled = true;
            this.menuButtonItem2.Enabled = true;
        }
    }
}

