﻿namespace H2Guerilla.Controls
{
    using core.TagInterface;
    using H2Guerilla;
    using System;
    using System.ComponentModel;
    using System.Drawing;
    using System.Windows.Forms;

    public class enums : UserControl
    {
        private BaseObject baseobject;
        private IContainer components;
        private Label label1;
        public bool nulled;
        private TextBox textBox1;
        private bool waitForSave = true;

        public enums(BaseObject BaseObject, bool Nulled)
        {
            this.baseobject = BaseObject;
            this.InitializeComponent();
            this.nulled = Nulled;
            this.label1.Text = this.baseobject.Name;
            Main.skin.skinChanged += new EventHandler(this.skin_skinChanged);
            this.BackColor = Main.skin.itemBackgroundColor;
            if (!Nulled)
            {
                this.LoadValue();
            }
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing && (this.components != null))
            {
                this.components.Dispose();
            }
            base.Dispose(disposing);
        }

        private void InitializeComponent()
        {
            this.label1 = new Label();
            this.textBox1 = new TextBox();
            base.SuspendLayout();
            this.label1.AutoSize = true;
            this.label1.Location = new Point(12, 6);
            this.label1.Name = "label1";
            this.label1.Size = new Size(0x23, 13);
            this.label1.TabIndex = 0;
            this.label1.Text = "label1";
            this.textBox1.Location = new Point(0xb6, 3);
            this.textBox1.Name = "textBox1";
            this.textBox1.Size = new Size(100, 20);
            this.textBox1.TabIndex = 1;
            this.textBox1.TextChanged += new EventHandler(this.textBox1_TextChanged);
            base.AutoScaleDimensions = new SizeF(6f, 13f);
            base.AutoScaleMode = AutoScaleMode.Font;
            this.AutoSize = true;
            base.AutoSizeMode = AutoSizeMode.GrowAndShrink;
            base.Controls.Add(this.textBox1);
            base.Controls.Add(this.label1);
            base.Name = "enums";
            base.Size = new Size(0x11d, 0x1a);
            base.ResumeLayout(false);
            base.PerformLayout();
        }

        private void LoadValue()
        {
            this.label1.Text = this.baseobject.Name;
            Enumerator baseobject = (Enumerator) this.baseobject;
            this.textBox1.Text = baseobject.Value.ToString();
            this.waitForSave = false;
        }

        public void ReloadWithNewBaseObject(BaseObject BaseObject)
        {
            this.baseobject = BaseObject;
            this.LoadValue();
        }

        private void SaveValue()
        {
            if (!this.nulled && !this.waitForSave)
            {
                Enumerator baseobject = (Enumerator) this.baseobject;
                baseobject.Value = int.Parse(this.textBox1.Text);
            }
        }

        public void SetNull()
        {
            this.nulled = true;
            this.textBox1.Clear();
        }

        private void skin_skinChanged(object sender, EventArgs e)
        {
            this.BackColor = Main.skin.itemBackgroundColor;
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            this.SaveValue();
        }
    }
}

