﻿namespace H2Guerilla.Forms
{
    using core;
    using core.TagInterface;
    using System;
    using System.ComponentModel;
    using System.Drawing;
    using System.Windows.Forms;

    public class ChooseType : Form
    {
        private Button button1;
        private IContainer components;
        private ListBox listBox1;
        public TagDefinition tagDef;

        public ChooseType()
        {
            this.InitializeComponent();
            base.DialogResult = DialogResult.Cancel;
            foreach (Tag_Category category in Tag_Layouts.Layouts)
            {
                if (category.HaloVersion == Map.HaloVersionEnum.Halo2)
                {
                    foreach (TagDefinition definition in category)
                    {
                        this.listBox1.Items.Add(definition.TagType);
                    }
                    continue;
                }
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            foreach (Tag_Category category in Tag_Layouts.Layouts)
            {
                if (category.HaloVersion == Map.HaloVersionEnum.Halo2)
                {
                    foreach (TagDefinition definition in category)
                    {
                        if (definition.TagType == this.listBox1.Text)
                        {
                            this.tagDef = definition;
                            break;
                        }
                    }
                    continue;
                }
            }
            base.DialogResult = DialogResult.OK;
            base.Close();
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing && (this.components != null))
            {
                this.components.Dispose();
            }
            base.Dispose(disposing);
        }

        private void InitializeComponent()
        {
            this.button1 = new Button();
            this.listBox1 = new ListBox();
            base.SuspendLayout();
            this.button1.Location = new Point(0x63, 0xe7);
            this.button1.Name = "button1";
            this.button1.Size = new Size(0x4b, 0x17);
            this.button1.TabIndex = 0;
            this.button1.Text = "Ok";
            this.button1.UseVisualStyleBackColor = true;
            this.button1.Click += new EventHandler(this.button1_Click);
            this.listBox1.FormattingEnabled = true;
            this.listBox1.Location = new Point(12, 12);
            this.listBox1.Name = "listBox1";
            this.listBox1.Size = new Size(0x10c, 0xd4);
            this.listBox1.TabIndex = 1;
            base.AutoScaleDimensions = new SizeF(6f, 13f);
            base.AutoScaleMode = AutoScaleMode.Font;
            base.ClientSize = new Size(0x124, 0x10a);
            base.Controls.Add(this.listBox1);
            base.Controls.Add(this.button1);
            base.Name = "ChooseType";
            this.Text = "ChooseType";
            base.ResumeLayout(false);
        }
    }
}

