﻿namespace H2Guerilla.Classes
{
    using System;
    using System.Windows.Forms;

    public sealed class StatusHelper
    {
        public static ToolStripStatusLabel reportLabel;
        public static ProgressBar reportProgress;

        public static void SetProgressMax(int Max)
        {
            if (reportProgress != null)
            {
                reportProgress.Maximum = Max;
                Application.DoEvents();
            }
        }

        public static void SetProgressValue(int Value)
        {
            if (reportProgress != null)
            {
                reportProgress.Value = Value;
                Application.DoEvents();
            }
        }

        public static void UpdateLabel(string Text)
        {
            if (reportLabel != null)
            {
                reportLabel.Text = Text;
                Application.DoEvents();
            }
        }
    }
}

