﻿namespace H2Guerilla.Controls
{
    using core.TagInterface;
    using H2Guerilla;
    using System;
    using System.ComponentModel;
    using System.Drawing;
    using System.Windows.Forms;

    public class colors : UserControl
    {
        private BaseObject baseobject;
        private IContainer components;
        private Label label1;
        private Label label2;
        private Label label3;
        private Label label4;
        private Label label5;
        public bool nulled;
        private PictureBox pictureBox1;
        private TextBox textBox1;
        private TextBox textBox2;
        private TextBox textBox3;
        private TextBox textBox4;
        private bool waitForSave = true;

        public colors(BaseObject BaseObject, bool Nulled)
        {
            this.baseobject = BaseObject;
            this.InitializeComponent();
            this.nulled = Nulled;
            this.label1.Text = this.baseobject.Name;
            Main.skin.skinChanged += new EventHandler(this.skin_skinChanged);
            this.BackColor = Main.skin.itemBackgroundColor;
            if (!Nulled)
            {
                this.LoadValue();
            }
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing && (this.components != null))
            {
                this.components.Dispose();
            }
            base.Dispose(disposing);
        }

        private void InitializeComponent()
        {
            this.label1 = new Label();
            this.textBox1 = new TextBox();
            this.textBox2 = new TextBox();
            this.textBox3 = new TextBox();
            this.textBox4 = new TextBox();
            this.label2 = new Label();
            this.label3 = new Label();
            this.label4 = new Label();
            this.label5 = new Label();
            this.pictureBox1 = new PictureBox();
            ((ISupportInitialize) this.pictureBox1).BeginInit();
            base.SuspendLayout();
            this.label1.AutoSize = true;
            this.label1.Location = new Point(12, 11);
            this.label1.Name = "label1";
            this.label1.Size = new Size(0x23, 13);
            this.label1.TabIndex = 0;
            this.label1.Text = "Name";
            this.textBox1.Location = new Point(0x12d, 11);
            this.textBox1.Name = "textBox1";
            this.textBox1.Size = new Size(0x48, 20);
            this.textBox1.TabIndex = 1;
            this.textBox1.TextChanged += new EventHandler(this.textBox1_TextChanged);
            this.textBox2.Location = new Point(400, 11);
            this.textBox2.Name = "textBox2";
            this.textBox2.Size = new Size(0x48, 20);
            this.textBox2.TabIndex = 2;
            this.textBox2.TextChanged += new EventHandler(this.textBox1_TextChanged);
            this.textBox3.Location = new Point(0x1f2, 11);
            this.textBox3.Name = "textBox3";
            this.textBox3.Size = new Size(0x48, 20);
            this.textBox3.TabIndex = 3;
            this.textBox3.TextChanged += new EventHandler(this.textBox1_TextChanged);
            this.textBox4.Location = new Point(0xca, 11);
            this.textBox4.Name = "textBox4";
            this.textBox4.Size = new Size(0x48, 20);
            this.textBox4.TabIndex = 4;
            this.textBox4.TextChanged += new EventHandler(this.textBox1_TextChanged);
            this.label2.AutoSize = true;
            this.label2.Location = new Point(280, 14);
            this.label2.Name = "label2";
            this.label2.Size = new Size(15, 13);
            this.label2.TabIndex = 5;
            this.label2.Text = "R";
            this.label3.AutoSize = true;
            this.label3.Location = new Point(0x17b, 14);
            this.label3.Name = "label3";
            this.label3.Size = new Size(15, 13);
            this.label3.TabIndex = 6;
            this.label3.Text = "G";
            this.label4.AutoSize = true;
            this.label4.Location = new Point(0x1de, 14);
            this.label4.Name = "label4";
            this.label4.Size = new Size(14, 13);
            this.label4.TabIndex = 7;
            this.label4.Text = "B";
            this.label5.AutoSize = true;
            this.label5.Location = new Point(0xb6, 14);
            this.label5.Name = "label5";
            this.label5.Size = new Size(14, 13);
            this.label5.TabIndex = 8;
            this.label5.Text = "A";
            this.pictureBox1.Location = new Point(0x240, 3);
            this.pictureBox1.Name = "pictureBox1";
            this.pictureBox1.Size = new Size(0x3e, 0x36);
            this.pictureBox1.TabIndex = 9;
            this.pictureBox1.TabStop = false;
            this.pictureBox1.Click += new EventHandler(this.pictureBox1_Click);
            base.AutoScaleDimensions = new SizeF(6f, 13f);
            base.AutoScaleMode = AutoScaleMode.Font;
            this.AutoSize = true;
            base.AutoSizeMode = AutoSizeMode.GrowAndShrink;
            base.Controls.Add(this.pictureBox1);
            base.Controls.Add(this.label5);
            base.Controls.Add(this.label4);
            base.Controls.Add(this.label3);
            base.Controls.Add(this.label2);
            base.Controls.Add(this.textBox4);
            base.Controls.Add(this.textBox3);
            base.Controls.Add(this.textBox2);
            base.Controls.Add(this.textBox1);
            base.Controls.Add(this.label1);
            base.Name = "colors";
            base.Size = new Size(0x281, 60);
            ((ISupportInitialize) this.pictureBox1).EndInit();
            base.ResumeLayout(false);
            base.PerformLayout();
        }

        private void LoadValue()
        {
            this.label1.Text = this.baseobject.Name;
            if (this.baseobject is RealRGBAColor)
            {
                RealRGBAColor baseobject = (RealRGBAColor) this.baseobject;
                this.textBox1.Text = baseobject.R.ToString();
                this.textBox2.Text = baseobject.G.ToString();
                this.textBox3.Text = baseobject.B.ToString();
                this.textBox4.Text = baseobject.A.ToString();
                this.textBox4.Enabled = true;
                this.pictureBox1.BackColor = Color.FromArgb((int) baseobject.A, (int) baseobject.R, (int) baseobject.G, (int) baseobject.B);
            }
            else if (this.baseobject is RGBAColor)
            {
                RGBAColor color2 = (RGBAColor) this.baseobject;
                this.textBox1.Text = color2.R.ToString();
                this.textBox2.Text = color2.G.ToString();
                this.textBox3.Text = color2.B.ToString();
                this.textBox4.Text = color2.A.ToString();
                this.textBox4.Enabled = true;
                this.pictureBox1.BackColor = Color.FromArgb(color2.A, color2.R, color2.G, color2.B);
            }
            else if (this.baseobject is RealRGBColor)
            {
                RealRGBColor color3 = (RealRGBColor) this.baseobject;
                this.textBox1.Text = color3.R.ToString();
                this.textBox2.Text = color3.G.ToString();
                this.textBox3.Text = color3.B.ToString();
                this.textBox4.Enabled = false;
                this.pictureBox1.BackColor = Color.FromArgb((int) color3.R, (int) color3.G, (int) color3.B);
            }
            this.waitForSave = false;
        }

        private void pictureBox1_Click(object sender, EventArgs e)
        {
            ColorDialog dialog = new ColorDialog();
            dialog.FullOpen = true;
            if (dialog.ShowDialog() == DialogResult.OK)
            {
                this.textBox1.Text = dialog.Color.R.ToString();
                this.textBox1.Text = dialog.Color.R.ToString();
                this.textBox1.Text = dialog.Color.R.ToString();
                if (this.textBox4.Enabled)
                {
                    this.textBox4.Text = dialog.Color.A.ToString();
                }
            }
        }

        public void ReloadWithNewBaseObject(BaseObject BaseObject)
        {
            this.baseobject = BaseObject;
            this.waitForSave = true;
            this.LoadValue();
        }

        private void SaveValue()
        {
            if (!this.waitForSave && !this.nulled)
            {
                if (this.baseobject is RealRGBAColor)
                {
                    RealRGBAColor baseobject = (RealRGBAColor) this.baseobject;
                    baseobject.R = float.Parse(this.textBox1.Text);
                    baseobject.G = float.Parse(this.textBox2.Text);
                    baseobject.B = float.Parse(this.textBox3.Text);
                    baseobject.A = float.Parse(this.textBox4.Text);
                    this.pictureBox1.BackColor = Color.FromArgb((int) baseobject.A, (int) baseobject.R, (int) baseobject.G, (int) baseobject.B);
                }
                else if (this.baseobject is RGBAColor)
                {
                    RGBAColor color2 = (RGBAColor) this.baseobject;
                    color2.R = byte.Parse(this.textBox1.Text);
                    color2.G = byte.Parse(this.textBox2.Text);
                    color2.B = byte.Parse(this.textBox3.Text);
                    color2.A = byte.Parse(this.textBox4.Text);
                    this.pictureBox1.BackColor = Color.FromArgb(color2.A, color2.R, color2.G, color2.B);
                }
                else if (this.baseobject is RealRGBColor)
                {
                    RealRGBColor color3 = (RealRGBColor) this.baseobject;
                    color3.R = byte.Parse(this.textBox1.Text);
                    color3.G = byte.Parse(this.textBox2.Text);
                    color3.B = byte.Parse(this.textBox3.Text);
                    this.pictureBox1.BackColor = Color.FromArgb((int) color3.R, (int) color3.G, (int) color3.B);
                }
            }
        }

        public void SetNull()
        {
            this.nulled = true;
            this.textBox1.Clear();
            this.textBox2.Clear();
            this.textBox3.Clear();
            this.textBox4.Clear();
        }

        private void skin_skinChanged(object sender, EventArgs e)
        {
            this.BackColor = Main.skin.itemBackgroundColor;
        }

        private void textBox1_TextChanged(object sender, EventArgs e)
        {
            this.SaveValue();
        }
    }
}

